org.apache.hc.core5.http.nio.support.classic

## Class AbstractClassicEntityProducer

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.classic.AbstractClassicEntityProducer

- All Implemented Interfaces:
    EntityDetails, AsyncDataProducer, AsyncEntityProducer, ResourceHolder

      public abstract class AbstractClassicEntityProducer
      extends Object
      implements AsyncEntityProducer

  `AsyncEntityProducer` implementation that acts as a compatibility layer for classic `OutputStream` based interfaces. Blocking output processing is executed through an `Executor`.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractClassicEntityProducer(int initialBufferSize, ContentType contentType, Executor executor)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Returns the number of bytes immediately available for output.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data generation.
    `String` | `getContentEncoding()` Gets content encoding of this entity, if known.
    `long` | `getContentLength()` Gets length of this entity, if known.
    `String` | `getContentType()` Gets content type of this entity, if known.
    `Exception` | `getException()`
    `Set<String>` | `getTrailerNames()` Gets the preliminary declaration of trailing headers.
    `boolean` | `isChunked()` Tests the chunked transfer hint for this entity.
    `boolean` | `isRepeatable()` Determines whether the producer can consistently produce the same content after invocation of `ResourceHolder.releaseResources()`.
    `void` | `produce(DataStreamChannel channel)` Triggered to signal the ability of the underlying data channel to accept more data.
    `protected abstract void` | `produceData(ContentType contentType, OutputStream outputStream)` Writes out entity data into the given stream.
    `void` | `releaseResources()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractClassicEntityProducer

          public AbstractClassicEntityProducer(int initialBufferSize,
                                               ContentType contentType,
                                               Executor executor)

  - ### Method Detail

    - #### produceData

          protected abstract void produceData(ContentType contentType,
                                              OutputStream outputStream)
                                       throws IOException

      Writes out entity data into the given stream.
      Parameters:
        `contentType` - the entity content type
        `outputStream` - the output stream
      Throws:
        `IOException` - in case of an I/O error.

    - #### isRepeatable

          public final boolean isRepeatable()

      Description copied from interface: `AsyncEntityProducer`
      Determines whether the producer can consistently produce the same content after invocation of `ResourceHolder.releaseResources()`.
      Specified by:
        `isRepeatable` in interface `AsyncEntityProducer`

    - #### available

          public final int available()

      Description copied from interface: `AsyncDataProducer`
      Returns the number of bytes immediately available for output. This method can be used as a hint to control output events of the underlying I/O session.

      Please note this method should return zero if the data producer is unable to produce any more data, in which case `AsyncDataProducer.produce(DataStreamChannel)` method will not get triggered. The producer can resume writing out data asynchronously once more data becomes available or request output readiness events with `DataStreamChannel.requestOutput()`.

      Specified by:
        `available` in interface `AsyncDataProducer`
      Returns:
        the number of bytes immediately available for output
      See Also:
        `AsyncDataProducer.produce(DataStreamChannel)`, `DataStreamChannel.requestOutput()`

    - #### produce

          public final void produce(DataStreamChannel channel)
                             throws IOException

      Description copied from interface: `AsyncDataProducer`
      Triggered to signal the ability of the underlying data channel to accept more data. The data producer can choose to write data immediately inside the call or asynchronously at some later point.

      Please note this method gets triggered only if `AsyncDataProducer.available()` returns a positive value.

      Specified by:
        `produce` in interface `AsyncDataProducer`
      Parameters:
        `channel` - the data channel capable of accepting more data.
      Throws:
        `IOException` - in case of an I/O error.
      See Also:
        `AsyncDataProducer.available()`

    - #### getContentLength

          public final long getContentLength()

      Description copied from interface: `EntityDetails`
      Gets length of this entity, if known.
      Specified by:
        `getContentLength` in interface `EntityDetails`
      Returns:
        the length of this entity, may be `0`.

    - #### getContentType

          public final String getContentType()

      Description copied from interface: `EntityDetails`
      Gets content type of this entity, if known.
      Specified by:
        `getContentType` in interface `EntityDetails`
      Returns:
        the content type of this entity, may be `null`.

    - #### getContentEncoding

          public String getContentEncoding()

      Description copied from interface: `EntityDetails`
      Gets content encoding of this entity, if known.
      Specified by:
        `getContentEncoding` in interface `EntityDetails`
      Returns:
        the content encoding of this entity, may be `null`.

    - #### isChunked

          public final boolean isChunked()

      Description copied from interface: `EntityDetails`
      Tests the chunked transfer hint for this entity.

      The behavior of wrapping entities is implementation dependent, but should respect the primary purpose.

      Specified by:
        `isChunked` in interface `EntityDetails`
      Returns:
        the chunked transfer hint for this entity.

    - #### getTrailerNames

          public final Set<String> getTrailerNames()

      Description copied from interface: `EntityDetails`
      Gets the preliminary declaration of trailing headers.
      Specified by:
        `getTrailerNames` in interface `EntityDetails`
      Returns:
        the preliminary declaration of trailing headers.

    - #### failed

          public final void failed(Exception cause)

      Description copied from interface: `AsyncEntityProducer`
      Triggered to signal a failure in data generation.
      Specified by:
        `failed` in interface `AsyncEntityProducer`
      Parameters:
        `cause` - the cause of the failure.

    - #### getException

          public final Exception getException()

    - #### releaseResources

          public void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.